// Roger P Wright  - preprocessor for a Wylie to Unicode parser and convertor.
// Copyright (C) 2003 Roger P Wright
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  Contact the author at Roger_Wright@attglobal.net
//
//  See the gnu_lic.txt file for the complete license.
//
#include <stdio.h>
#include <string.h>
#include "strcmpl.c"
char iline [4096] ;
char oline [4096] ;
char ostr  [4096] ;
/*uni1_trans*/
int uni1_trans (char *iptr, char * ostr)
{
   int syll_len ;
/* return first charcter of input string as a string of length one */
/* function value is length of input 'syllable' translated  */
   *ostr = '\0' ;
   if (
       (strcmpl(iptr, "||") == 0)
      )
     {
        strcat(ostr, ",,") ;
        return 2 ;
     }
   if (
       (strcmpl(iptr, "|") == 0)
      )
     {
        strcat(ostr, ",") ;
        return 1 ;
     }
   if (
       (strcmpl(iptr, "//") == 0)
      )
     {
        strcat(ostr, ",,") ;
        return 2 ;
     }
   if (
       (strcmpl(iptr, "/") == 0)
      )
     {
        strcat(ostr, ",") ;
        return 1 ;
     }
   if (
       (strcmpl(iptr, "Th") == 0)
      )
     {
        strcat(ostr, "W") ;
        return 2 ;
     }
   if (
       (strcmpl(iptr, "T") == 0)
      )
     {
        strcat(ostr, "V") ;
        return 1 ;
     }
   if (
       (strcmpl(iptr, "Dh") == 0)
      )
     {
        strcat(ostr, "Y") ;
        return 2 ;
     }
   if (
       (strcmpl(iptr, "D") == 0)
      )
     {
        strcat(ostr, "X") ;
        return 1 ;
     }
   if (
       (strcmpl(iptr, "N") == 0)
      )
     {
        strcat(ostr, "L") ;
        return 1 ;
     }
   if (
       (strcmpl(iptr, "Sh") == 0)
      )
     {
        strcat(ostr, "S") ;
        return 2 ;
     }
   if (
       (strcmpl(iptr, "M") == 0)
      )
     {
        strcat(ostr, "M") ;
        return 1 ;
     }
   if (
       (strcmpl(iptr, "H") == 0)
      )
     {
        strcat(ostr, "H") ;
        return 1 ;
     }
   if (
       (strcmpl(iptr, "kSh") == 0)
      )
     {
        strcat(ostr, "F") ;
        return 3 ;
     }
   if (
       (strcmpl(iptr, "k+Sh") == 0)
      )
     {
        strcat(ostr, "F") ;
        return 4 ;
     }
   if (
       (strcmpl(iptr, "A") == 0)
      )
     {
        strcat(ostr, "A") ;
        return 1 ;
     }
   if (
       (strcmpl(iptr, "I") == 0)
      )
     {
        strcat(ostr, "I") ;
        return 1 ;
     }
   if (
       (strcmpl(iptr, "U") == 0)
      )
     {
        strcat(ostr, "U") ;
        return 1 ;
     }
/*                                                             */
   if (
       (strcmpl(iptr, "+Y") == 0)
      )
     {
        strcat(ostr, "+y") ;
        return 2 ;
     }
   if (
       (strcmpl(iptr, "+R") == 0)
      )
     {
        strcat(ostr, "+r") ;
        return 2 ;
     }
   if (
       (strcmpl(iptr, "+y") == 0)
      )
     {
        strcat(ostr, "y") ;
        return 2 ;
     }
   if (
       (strcmpl(iptr, "+w") == 0)
      )
     {
        strcat(ostr, "w") ;
        return 2 ;
     }
   if (
       (strcmpl(iptr, "+r") == 0)
      )
     {
        strcat(ostr, "r") ;
        return 2 ;
     }
/* if (                                                        */
/*     (strcmpl(iptr, "R") == 0)                               */
/*    )                                                        */
/*   {                                                         */
/*      strcat(ostr, "r") ;                                    */
/*      return 1 ;                                             */
/*   }                                                         */
/* if (                                                        */
/*     (strcmpl(iptr, "rI") == 0)                              */
/*    )                                                        */
/*   {                                                         */
/*      strcat(ostr, "\x1b") ;                                 */
/*      return 2 ;                                             */
/*   }                                                         */
/* if (                                                        */
/*     (strcmpl(iptr, ".R") == 0)                              */
/*    )                                                        */
/*   {                                                         */
/*      strcat(ostr, "\x11") ;                                 */
/*      return 2 ;                                             */
/*   }                                                         */
/* if (                                                        */
/*     (strcmpl(iptr, "r\'I") == 0)                            */
/*    )                                                        */
/*   {                                                         */
/*      strcat(ostr, "\x11") ;                                 */
/*      return 3 ;                                             */
/*   }                                                         */
/* if (                                                        */
/*     (strcmpl(iptr, "lI") == 0)                              */
/*    )                                                        */
/*   {                                                         */
/*      strcat(ostr, "\x18") ;                                 */
/*      return 2 ;                                             */
/*   }                                                         */
/* if (                                                        */
/*     (strcmpl(iptr, ".L") == 0)                              */
/*    )                                                        */
/*   {                                                         */
/*      strcat(ostr, "\x19") ;                                 */
/*      return 2 ;                                             */
/*   }                                                         */
/* if (                                                        */
/*     (strcmpl(iptr, "l\'I") == 0)                            */
/*    )                                                        */
/*   {                                                         */
/*      strcat(ostr, "\x19") ;                                 */
/*      return 3 ;                                             */
/*   }                                                         */
   if (
       (strcmpl(iptr, "r-i") == 0)
      )
     {
        strcat(ostr, "\x1b") ;
        return 3 ;
     }
   if (
       (strcmpl(iptr, "r-I") == 0)
      )
     {
        strcat(ostr, "\x11") ;
        return 3 ;
     }
/* if (                                                    */
/*     (strcmpl(iptr, ".l") == 0)                          */
/*    )                                                    */
/*   {                                                     */
/*      strcat(ostr, "\x18") ;                             */
/*      return 2 ;                                         */
/*   }                                                     */
   if (
       (strcmpl(iptr, "l-i") == 0)
      )
     {
        strcat(ostr, "\x18") ;
        return 3 ;
     }
   if (
       (strcmpl(iptr, "l-I") == 0)
      )
     {
        strcat(ostr, "\x19") ;
        return 3 ;
     }
/* now change any remaining U/case to L/case */
   if ( tolower(iptr[0]) != iptr[0] )
     {
       fputc(iptr[0] ,stderr) ;
       fprintf(stderr, " - illegal upper case - converting to lower\n") ;
       iptr[0] = tolower(iptr[0]) ;
     }
/*                                                             */
/* if (                                                        */
/*     (strcmpl(iptr, "v") == 0)                               */
/*    )                                                        */
/*   {                                                         */
/*      strcat(ostr, "w") ;                                    */
/*      return 1 ;                                             */
/*   }                                                         */
   if (
       (strcmpl(iptr, "kh") == 0)
      )
     {
        strcat(ostr, "K") ;
        return 2 ;
     }
   if (
       (strcmpl(iptr, "gh") == 0)
      )
     {
        strcat(ostr, "G") ;
        return 2 ;
     }
   if (
       (strcmpl(iptr, "ng") == 0)
      )
     {
        strcat(ostr, "R") ;
        return 2 ;
     }
   if (
       (strcmpl(iptr, "\"n") == 0)
      )
     {
        strcat(ostr, "R") ;
        return 2 ;
     }
   if (
       (strcmpl(iptr, "ch") == 0)
      )
     {
        strcat(ostr, "C") ;
        return 2 ;
     }
   if (
       (strcmpl(iptr, "jh") == 0)
      )
     {
        strcat(ostr, "v") ;
        return 2 ;
     }
   if (
       (strcmpl(iptr, "dzh") == 0)
      )
     {
        strcat(ostr, "J") ;
        return 3 ;
     }
   if (
       (strcmpl(iptr, "ny") == 0)
      )
     {
        strcat(ostr, "N") ;
        return 2 ;
     }
/*                                                             */
/* if (                                                        */
/*     (strcmpl(iptr, "~n") == 0)                              */
/*    )                                                        */
/*   {                                                         */
/*      strcat(ostr, "N") ;                                    */
/*      return 2 ;                                             */
/*   }                                                         */
   if (
       (strcmpl(iptr, "n.y") == 0)
      )
     {
        strcat(ostr, "ny") ;
        return 3  ;
     }
/*                                                             */
/* if (                                                        */
/*     (strcmpl(iptr, ".th") == 0)                             */
/*    )                                                        */
/*   {                                                         */
/*      strcat(ostr, "W") ;                                    */
/*      return 3 ;                                             */
/*   }                                                         */
/* if (                                                        */
/*     (strcmpl(iptr, ".t") == 0)                              */
/*    )                                                        */
/*   {                                                         */
/*      strcat(ostr, "V") ;                                    */
/*      return 2 ;                                             */
/*   }                                                         */
/* if (                                                        */
/*     (strcmpl(iptr, ".dh") == 0)                             */
/*    )                                                        */
/*   {                                                         */
/*      strcat(ostr, "Y") ;                                    */
/*      return 3 ;                                             */
/*   }                                                         */
/* if (                                                        */
/*     (strcmpl(iptr, ".d") == 0)                              */
/*    )                                                        */
/*   {                                                         */
/*      strcat(ostr, "X") ;                                    */
/*      return 2 ;                                             */
/*   }                                                         */
/* if (                                                        */
/*     (strcmpl(iptr, ".n") == 0)                              */
/*    )                                                        */
/*   {                                                         */
/*      strcat(ostr, "L") ;                                    */
/*      return 2 ;                                             */
/*   }                                                         */
   if (
       (strcmpl(iptr, "th") == 0)
      )
     {
        strcat(ostr, "T") ;
        return 2 ;
     }
   if (
       (strcmpl(iptr, "dh") == 0)
      )
     {
        strcat(ostr, "D") ;
        return 2 ;
     }
   if (
       (strcmpl(iptr, "ph") == 0)
      )
     {
        strcat(ostr, "P") ;
        return 2 ;
     }
   if (
       (strcmpl(iptr, "bh") == 0)
      )
     {
        strcat(ostr, "B") ;
        return 2 ;
     }
   if (
       (strcmpl(iptr, "tsh") == 0)
      )
     {
        strcat(ostr, "Q") ;
        return 3 ;
     }
   if (
       (strcmpl(iptr, "ts") == 0)
      )
     {
        strcat(ostr, "q") ;
        return 2 ;
     }
   if (
       (strcmpl(iptr, "dz") == 0)
      )
     {
        strcat(ostr, "x") ;
        return 2 ;
     }
   if (
       (strcmpl(iptr, "zh") == 0)
      )
     {
        strcat(ostr, "Z") ;
        return 2 ;
     }
   if (
       (strcmpl(iptr, "sh") == 0)
      )
     {
        strcat(ostr, "f") ;
        return 2 ;
     }
/*                                                             */
/* if (                                                        */
/*     (strcmpl(iptr, ".s") == 0)                              */
/*    )                                                        */
/*   {                                                         */
/*      strcat(ostr, "S") ;                                    */
/*      return 2 ;                                             */
/*   }                                                         */
   if (
       (strcmpl(iptr, "\"s") == 0)
      )
     {
        strcat(ostr, "f") ;
        return 2 ;
     }
/* if (                                                        */
/*     (strcmpl(iptr, "k.s") == 0)                             */
/*    )                                                        */
/*   {                                                         */
/*      strcat(ostr, "F") ;                                    */
/*      return 3 ;                                             */
/*   }                                                         */
/*                                                             */
/* if (                                                        */
/*     (strcmpl(iptr, ".h") == 0)                              */
/*    )                                                        */
/*   {                                                         */
/*      strcat(ostr, "H") ;                                    */
/*      return 2 ;                                             */
/*   }                                                         */
   if (
       (strcmpl(iptr, ":") == 0)
      )
     {
        strcat(ostr, "H") ;
        return 1 ;
     }
/* if (                                                        */
/*     (strcmpl(iptr, ".m") == 0)                              */
/*    )                                                        */
/*   {                                                         */
/*      strcat(ostr, "M") ;                                    */
/*      return 2 ;                                             */
/*   }                                                         */
/* if (                                                    */
/*     (strcmpl(iptr, ".o") == 0)                          */
/*    )                                                    */
/*   {                                                     */
/*      strcat(ostr, "oM") ;                               */
/*      return 2 ;                                         */
/*   }                                                     */
/*                                                         */
/* if (                                                    */
/*     (strcmpl(iptr, ".r") == 0)                          */
/*    )                                                    */
/*   {                                                     */
/*      strcat(ostr, "\x1b") ;                             */
/*      return 2 ;                                         */
/*   }                                                     */
/*                                                             */
/* if (                                                        */
/*     (strcmpl(iptr, "aa") == 0)                              */
/*    )                                                        */
/*   {                                                         */
/*      strcat(ostr, "A") ;                                    */
/*      return 2 ;                                             */
/*   }                                                         */
/* if (                                                        */
/*     (strcmpl(iptr, "ii") == 0)                              */
/*    )                                                        */
/*   {                                                         */
/*      strcat(ostr, "I") ;                                    */
/*      return 2 ;                                             */
/*   }                                                         */
/* if (                                                        */
/*     (strcmpl(iptr, "uu") == 0)                              */
/*    )                                                        */
/*   {                                                         */
/*      strcat(ostr, "U") ;                                    */
/*      return 2 ;                                             */
/*   }                                                         */
   if (
       (strcmpl(iptr, "ai") == 0)
      )
     {
        strcat(ostr, "E") ;
        return 2 ;
     }
   if (
       (strcmpl(iptr, "au") == 0)
      )
     {
        strcat(ostr, "O") ;
        return 2 ;
     }
/*                                                             */
/* if (                                                        */
/*     (strcmpl(iptr, "oo") == 0)                              */
/*    )                                                        */
/*   {                                                         */
/*      strcat(ostr, "O") ;                                    */
/*      return 2 ;                                             */
/*   }                                                         */
   if (
       (strcmpl(iptr, " ") == 0)
      )
     {
        strcat(ostr, "/") ;
        return 1 ;
     }
   if (
       (strcmpl(iptr, "-") == 0)
      )
     {
        strcat(ostr, "/") ;
        return 1 ;
     }
   if (
       (strcmpl(iptr, "g.y") == 0)
      )
     {
        strcat(ostr, "g.y") ;
        return 3 ;
     }
   if (
       (strcmpl(iptr, ".") == 0)
      )
     {
        strcat(ostr, "/") ;
        return 1 ;
     }
   if (
       (strcmpl(iptr, "+") == 0)
      )
     {
        strcat(ostr, "+") ;
        return 1 ;
     }
   strncat( ostr, iptr, 1) ;
   syll_len = 1 ;
   return syll_len ;
}



/*filecopy*/
void filecopy (FILE *ifp, FILE *ofp)
{
   char *iptr ;
   char *optr ;
   int i ;

   iptr = fgets(iline, 4096, ifp) ;
   while (iptr != NULL)
      {
       iptr = iline ;
       *oline = '\0' ;
       optr = oline ;
       /* loop until end-of-line*/
       while (
              *iptr != '\0'
             )
         {
           iptr = iptr + uni1_trans( iptr , ostr) ;
           strcat( optr, ostr) ;
         }
       fputs(oline, ofp) ;
       iptr = fgets(iline, 4096, ifp) ;

      }

}


main ( int argc, char*argv[] )
{
   FILE *ifp, *ofp ;
   void filecopy(FILE *, FILE *) ;

   if (argc != 3) /* wrong args */
      {
       printf("unitran1: wrong number of arguments");
       exit(1) ;
      }
   else
      {
       if ( strcmpl( *(argv + 1), "stdin:") == 0 )
         {
           ifp = stdin ;
         }
       else
         {
           if ((ifp = fopen(*(argv + 1), "r") ) == NULL)
             {
              printf("unitran1 can't open %s\n", *(argv + 1)) ;
              exit(1) ;
             }
         }
       if ( strcmpl( *(argv + 2), "stdout:") == 0 )
         {
           ofp = stdout ;
         }
       else
         {
           if ((ofp = fopen(*(argv + 2), "w" )) == NULL)
             {
              printf("unitran1 can't open %s\n", *(argv + 2)) ;
              exit(1) ;
             }
         }

/*     iptr = fgets(iline, 4096, ifp) ;  /**/
       filecopy( ifp, ofp ) ;
       fclose (ifp);
       fclose (ofp);
      }
   exit(0);
}
